from pycsp3 import *

# Problem 015 at CSPLib

'''
  Schurr's lemma problem.
  One variant corresponds to the one proposed by [Bessiere Meseguer Freuder Larrosa, On forward checking for non-binary constraint satisfaction, 2002].
'''

n, d = data.nBalls, data.nBoxes

# x[i] is the box where the ith ball is put
x = VarArray(size=n, dom=range(d))

satisfy(
    AllDifferent(x[i], x[j], x[k]) if variant("mod") else NotAllEqual(x[i], x[j], x[k]) for (i, j, k) in product(range(n), repeat=3) if i < j and i + 1 + j == k
)
