from pycsp3 import *

n = data.n
clues = data.clues

# x[i][j] is the value at row i and col j of the Latin Square
x = VarArray(size=[n, n], dom=range(n))

satisfy(
    AllDifferent(x, matrix=True),

    # tag(clues)
    [x[clue.x][clue.y] == clue.value for clue in clues],

    # tag(diagonals)
    [
        [AllDifferent(diagonal) for diagonal in diagonals_down(x, broken=True)],

        [AllDifferent(diagonal) for diagonal in diagonals_up(x, broken=True)]
    ]
)
