from pycsp3.problems.tests.tester import Tester, run

NAME = "g2_academic"

diff = (Tester(NAME)
        .add("CryptoPuzzle", data="[DONALD,GERALD,ROBERT]")  # ok, aggregation more compact (subgroups in JvCSP)
        .add("GolombRuler", data="8", variant="dec")  # ok, predicate expressions more general (2 sub-groups in JvCSP)
        .add("Ortholatin", data="10")  # ok, instantiation more compact
        .add("SocialGolfers", data="[4,4,5]")  # ok, instantiation more compact
        .add("SocialGolfers", data="[4,4,5]", variant="01")  # ok, block not formed in JvCSP for lex constraints
        .add("SportsScheduling", data="10")  # ok, class 'dummyweek' put before if in JvCSP
        .add("StillLife", data="[8,8]", variant="wastage")  # ok, instantiation more compact
        .add("Talisman", data="[4,4]")  # ok, aggregation more compact (several groups in JvCSP)
        )

same = (Tester(NAME)
        .add("AllInterval", data="10")
        .add("AllInterval", data="10", variant="aux")
        .add("Bibd", data="[9,0,0,3,9]")
        .add("Bibd", data="[9,0,0,3,9]", variant="aux")
        .add("BoardColoration", data="[8,10]")
        .add("ChangeMaking", data="10")
        .add("ColouredQueens", data="10")
        .add("CoveringArray", data="[3,5,2,10]")
        .add("CryptoPuzzle", data="[SEND,MORE,MONEY]")
        .add("DeBruijnSequence", data="[2,5]")
        .add("DiamondFree", data="10")
        .add("Dubois", data="10")
        .add("Enigme5", data="[364,55440]")
        .add("GolombRuler", data="8")
        .add("GolombRuler", data="8", variant="aux")
        .add("GracefulGraph", data="[3,5]")
        .add("KnightTour", data="16")
        .add("KnightTour", data="16", variant="table-2")
        .add("KnightTour", data="16", variant="table-3")
        .add("Langford", data="[16,4]")
        .add("LangfordBin", data="16")
        .add("LowAutocorrelation", data="16")
        .add("MagicHexagon", data="[4,10]")
        .add("MagicSequence", data="10")
        .add("NumberPartitioning", data="10")
        .add("Opd", data="[4,4,4]")
        .add("Opd", data="[4,6,4]", variant="aux")
        .add("PeacableArmies", data="10", variant="m1")
        .add("PeacableArmies", data="10", variant="m2")
        .add("QuasiGroup", data="10", variant="aux-v3")
        .add("QuasiGroup", data="10", variant="aux-v4")
        .add("QuasiGroup", data="10", variant="aux-v5")
        .add("QuasiGroup", data="10", variant="aux-v7")
        .add("QueenAttacking", data="10")
        .add("Queens", data="10")
        .add("Queens", data="10", variant="v1")
        .add("Queens", data="10", variant="v2")
        .add("Ramsey", data="10")
        .add("SchurrLemma", data="[10,10]")
        .add("SchurrLemma", data="[10,10]", variant="mod")
        .add("Steiner3", data="6")
        .add("StillLife", data="[8,8]")
        .add("WaterBucket", data="[8,6,4,6,6,6,8]")
        )

xcsp = (Tester(NAME)
        .add(same.instances)
        )

inprogress = (Tester(NAME)
              .add("QuasiGroup", data="10", variant="base-v3")
              .add("QuasiGroup", data="10", variant="base-v4")
              .add("CostasArray", data="10")
              .add("CoinsGrid", data="[10,4]")
              # .add("QuasiGroup", data="10", variant="aux-v5")
              # .add("QuasiGroup", data="10", variant="base-v6")
              # .add("QuasiGroup", data="10", variant="aux-v7")
              )

run(diff, same, xcsp)
